------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3786 $ $Date: 2010-10-27 11:09:19 +0400 (Wed, 27 Oct 2010) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Events.Registry;

package body Qt4.Shortcut_Events is

   function isAmbiguous_wrapper
    (Self : not null access Qt_Ada.Internals.Events.QEvent)
      return Qt4.bool;
   pragma Import
    (C, isAmbiguous_wrapper, "__Qt4Ada_QShortcutEvent_isAmbiguous_wrapper");

--    function key_wrapper
--     (Self : not null access Qt_Ada.Internals.Events.QEvent)
--       return not null access Qt4.Key_Sequences.Impl.QKeySequence;
--    pragma Import
--     (C, key_wrapper, "__Qt4Ada_QShortCutEvent_key_wrapper");

   function shortcutId_wrapper
    (Self : not null access Qt_Ada.Internals.Events.QEvent)
      return Interfaces.C.int;
   pragma Import
    (C, shortcutId_wrapper, "__Qt4Ada_QShortcutEvent_shortcutId_wrapper");

   function Create
    (Object : not null Qt_Ada.Internals.Events.QEvent_Access)
       return not null Qt4.Events.Q_Event_Access;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Events.QEvent_Access)
       return not null Qt4.Events.Q_Event_Access is
   begin
      return Result : constant not null Qt4.Events.Q_Event_Access
        := new Q_Shortcut_Event
      do
         Qt_Ada.Internals.Events.Initialize (Result, Object);
      end return;
   end Create;

   ------------------
   -- Is_Ambiguous --
   ------------------

   function Is_Ambiguous
    (Self : not null access constant Q_Shortcut_Event'Class)
       return Boolean is
   begin
      return Qt4.To_Boolean (isAmbiguous_wrapper (Self.QEvent_View));
   end Is_Ambiguous;

   --    function Key (Self : not null access Q_Shortcut_Event_Impl)
   --      return Q_Key_Sequence
   --    is
   --    begin
   --       return Qt4.Key_Sequences.Internals.To_Q_Key_Sequence
   --               (key_wrapper (Self.QEvent_View);
   --    end Key;

   -----------------
   -- Shortcut_Id --
   -----------------

   function Shortcut_Id
    (Self : not null access constant Q_Shortcut_Event'Class)
       return Q_Integer is
   begin
      return Qt4.Q_Integer (shortcutId_wrapper (Self.QEvent_View));
   end Shortcut_Id;

begin
   Qt_Ada.Internals.Events.Registry.Register
    (Qt4.Events.Shortcut, Create'Access);
end Qt4.Shortcut_Events;
